import pygame, sys, os, math
from pygame.locals import *
import matplotlib.pyplot as plt

def rotate_player_to_angle_and_translate(arena,player_image, angle,curPosX,curPosY):
    """rotate a Surface, maintaining position."""
    rot_sprite = pygame.transform.rotozoom(player_image, angle,1) #This rotates an image around angle degrees
    rect = rot_sprite.get_rect(center=(curPosX,curPosY)) #This centers the rotated image on its old position
    arena.blit(rot_sprite, rect) #Updates the screen
    return rot_sprite
    

#Initial Position and Rotation of the Player
#Change these during the loop to update the players Position    
player_pos_x = 50 
player_pos_y = 300
playerHeading = 0

player_positions_x = [60,70,80,90,100,120,140,160,180,200,230,260,290,300,310,320,330,360,410,390,350,330,330,340,350,370,390,410,440,480,520,550,600,650,670,690,700,710,720,720,720]

pygame.init() #Initialize the pygame module
screen = pygame.display.set_mode((800, 600)) #Define a 800,600 screen

player_original = pygame.image.load(os.path.join("braitenberg.png")) #Load the braitenberg image. It has to be located in the same folder as this script!
player_original.convert() #This function converts the loaded image to game sprite

for pos_x in player_positions_x: #The pygame Loop runs for all position commands
    for event in pygame.event.get(): #This loop makes sure that the X-Button works!
            if event.type == QUIT:
                pygame.quit() #Quit the game in case of x-button press
                sys.exit()


    screen.fill((255,255,255)) # In each loop we will redraw the screen with white color


    playerHeading = 0 #The heading stays the same for now
    
    player_pos_x = pos_x  #Change the positions to the position specified in the list
    player_pos_y = player_pos_y
    
    #These two functions apply the calculated rotation and translation of the player
    rotate_player_to_angle_and_translate(screen,player_original,playerHeading,player_pos_x,player_pos_y)
        
		
    pygame.display.flip() # This shows all the updates
    pygame.time.delay(40) #This puts a delay between each loop iteration

############## HOW FAST WAS THE PLAYER?
############## USE NUMERICAL DIFFERENTIATION TO CALCULATE A LIST OF VELOCITIES
player_velocities_x = [0] ### Append all velocities to this list. The starting velocity is 0

##The list of positions is found in the list: player_positions_x 
#
#
#
# YOUR CODE HERE    
#
#
### At the end we plot the positions # If you are done you may add your velocity plot 
plt.plot(player_positions_x)
plt.ylabel('x - position')
plt.xlabel('time steps')
plt.title('The Braitenberg\'s Position')

plt.show()   
    
pygame.quit()